import { Vector3 } from "three";
/**
 * 轨道控制的数学类,观察向量和角度的互相转换
 * 当x当抬头或者低头到90度时,触发万向锁.
 *
 * @class Orbit
 */
export declare class Orbit {
    private m_RoX;
    RoZ: number;
    get RoX(): number;
    set RoX(v: number);
    /**
     * 使用旋转角度 计算观察向量
     *
     * @param {Vector3} [dir] 引用传入,如果传入,那么就不构造新的向量
     * @returns {Vector3} 返回观察向量
     * @memberof Orbit
     */
    UpdateDirection(dir?: Vector3): Vector3;
    /**
     * 使用观察向量,计算旋转角度
     *
     * @param {Vector3} dir
     * @memberof Orbit
     */
    UpdateRoValue(dir: Vector3): void;
    /**
     *
     * 根据观察向量 求头部的向量.
     *
     * @static
     * @param {Vector3} dir
     * @param {Vector3} [up]
     * @returns {Vector3}
     * @memberof Orbit
     */
    static ComputUpDirection(dir: Vector3, up?: Vector3): Vector3;
}
